clear;
nX = 101;
nZ = round(nX/2);
L = 1;
x = linspace(-L, L, nX);
z = linspace(0, L, nZ);
[x,z] = meshgrid(x,z);

kB = 10/L;

kvec = linspace(.1*kB, 2*kB, 200);
for i = 1 : length(kvec)
    k = kvec(i);
    kz = -1i * sqrt(kB^2 - k^2);
    
    P = k/kz;
    
    p = P * exp(-1i*(kB * x + kz * z));
    if i == 1
        subplot(1,7,1:6);
        hp = surf(x, z, real(p)); view(2); shading interp;
        colorbar;
        caxis([-3, 3]);
        xlabel('x [m]');
        ylabel('z [m]');
        subplot(1,7,7);
        hp2 = bar(k/kB);
        axis tight;
        ylabel('k/k_B');
        ylim([0 2]);
    else
        set(hp, 'ZData', p);
        set(hp2, 'YData', k/kB);
    end
    pause(.1);
end
